//+------------------------------------------------------------------+
//|                                               Ambush_III_GBP.mq4 |
//|                                           kris.pivo[at]gmail.com |
//|     Based on David Willis' TheOnlyPivot_multi.mq4 expert advisor |
//|                                mini-account on IBFX platform GMT |
//+------------------------------------------------------------------+
#property copyright " Kris, 2008"

extern double  Lots = 9;  
extern int     JP_open =  3;  // 0=10,542; 1=10,645; 2=14,811;  3=17,013;  4=14,163;  5=13,371
extern int     EU_open = 10;  // 6=2,623;  7=5,634;  8= 8,475;  9=14,901; 10=17,013; 11=13,941
extern int     US_open = 14;  //11=5,877; 12=9,192; 13=14,955; 14=17,013; 15=15,468
extern int     endtradingtime=20;
extern int     slippage = 5;
extern int     MagicNumber = 12358;
extern int     buffer=0;
extern int     enday=22;
extern int     endayfriday=20;
extern int     SpikeStopLoss=50;

//+------------------------------------------------------------------+
int init()
  {
   return(0);
  }
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
int start()
{
 int numbertrades=3;
 int tradedirection=tradedirection();
 double sl,tp1,tp2,tp3;
 double LongPT3    = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,0,0); // Fibonacci Extension +1.618
 double LongPT2    = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,1,0); // Fibonacci Extension +1.272
 double LongPT1    = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,2,0); // Previous Session High
 double AmbushHigh = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,3,0); // Fibonacci 0.618
 double StopLong   = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,4,0); // Fibonacci 0.382
 double StopShort  = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,3,0); // Fibonacci 0.618
 double AmbushLow  = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,4,0); // Fibonacci 0.382
 double ShortPT1   = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,5,0); // Previous Session Low
 double ShortPT2   = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,6,0); // Fibonacci Extension -1.272
 double ShortPT3   = iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,7,0); // Fibonacci Extension -1.618
 
 double SpikeStopLong  = AmbushHigh - (SpikeStopLoss*Point);
 double SpikeStopShort = AmbushLow  + (SpikeStopLoss*Point);
 
 int Start_time=startime(); 

// Take care of open trades
 if(opentrades()>0)
 {
 // close at end of day
  if(endofday()>0) 
  {
   closealltrades();
   return(0);
  } 
  if(tradedirection==1) {modifystoploss(LongPT1, LongPT2, AmbushHigh,LongPT1);}
  if(tradedirection==0) {modifystoploss(ShortPT1,ShortPT2,AmbushLow,ShortPT1);}
  // if close on opposite side of range close all trades
  if(tradedirection==1 && (Close[1]<StopLong  || Close[0]<SpikeStopLong))  {closealltrades();}
  if(tradedirection==0 && (Close[1]>StopShort || Close[0]>SpikeStopShort)) {closealltrades();} 
}
 // No open trades, or not all open trades 
 if(tradingtime(Start_time)>0 && opentrades()<1) 
 {
  //Start of day
  if(Hour()==Start_time+1) // && Minute()==0)
  {
// LONG entry at beginning of day
   if(Close[1]>AmbushHigh && Close[0]>AmbushHigh && Close[0]<LongPT1 && Open[1]<Close[1])
   {
    sl=0; // use the close of other side to exit
    tp1=LongPT1;
    tp2=LongPT2;
    tp3=LongPT3; 
    
    if (opentrades()==0)
    {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Blue);}
    if(opentrades()<=1)
    {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Blue);}
    if(opentrades()<=2)
    {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Blue);}
   }
// SHORT entry at beginning of day
   if(Close[1]<AmbushLow && Close[0]<AmbushLow && Close[0]>ShortPT1 && Open[1]>Close[1])
   {
    sl=0;
    tp1=ShortPT1;
    tp2=ShortPT2;
    tp3=ShortPT3;
      
    if(opentrades()==0)
    {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Red);}
    if(opentrades()<=1)
    {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Red);}
    if(opentrades()<=2)
    {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Red);}
   }
  }
 }      
 // New close above or below pivot range 
 if (tradingtime(Start_time)>0 && opentrades()<1) // && Minute()==0)
 {
// LONG entry during the day
   if(Low[2]<AmbushHigh && Close[1]>AmbushHigh && Close[0]>AmbushHigh && Close[0]<LongPT1 && Open[1]<Close[1])
// if(Close[2]>AmbushHigh && Low[1]<AmbushHigh && Close[1]>AmbushHigh && Open[1]<Close[1])
   {
   sl=0; // use the close of other side to exit
   tp1=LongPT1;
   tp2=LongPT2;
   tp3=LongPT3; 
    
   if (opentrades()==0)
   {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Blue);}
   if(opentrades()<=1)
   {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Blue);}
   if(opentrades()<=2)
   {OrderSend(Symbol(),OP_BUY,Lots/numbertrades,Ask,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Blue);}
 }
// SHORT entry during the day
   if(High[2]>AmbushLow && Close[1]<AmbushLow && Close[0]<AmbushLow && Close[0]>ShortPT1 && Open[1]>Close[1])
// if(Close[2]<AmbushLow && High[1]>AmbushLow && Close[1]<AmbushLow && Open[1]>Close[1])
   {
   sl=0;
   tp1=ShortPT1;
   tp2=ShortPT2;
   tp3=ShortPT3;
      
   if(opentrades()==0)
   {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp1,"Only"+MagicNumber,MagicNumber,0,Red);}
   if(opentrades()<=1)
   {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp2,"Only"+MagicNumber,MagicNumber,0,Red);}
   if(opentrades()<=2)
   {OrderSend(Symbol(),OP_SELL,Lots/numbertrades,Bid,slippage,sl,tp3,"Only"+MagicNumber,MagicNumber,0,Red);}
  }
 }
 return(0); 
}
//+------------------------------------------------------------------+

int startime()
{
 int cnt, startime;
 
 for(cnt=0;cnt<24;cnt++)
 {
  if(iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,0,cnt+1)!=iCustom(NULL,0,"Ambush_Fibs",JP_open,EU_open,US_open,0,cnt))
  {
   startime=Hour()-cnt;
   if (startime<0){startime=startime+24;}
   return(startime);
  }
 }
}

void modifystoploss(double sla1,double sla2, double sl1,double sl2)
{
  int cnt;
  double buyprice, currentsl,newsl=0;
  
  
  //find current buyprice and stop loss
  for(cnt=0;cnt<OrdersTotal();cnt++)   
    {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
      {
        buyprice=OrderOpenPrice();
        currentsl=OrderStopLoss();
      }
    }  

  //for long trades
  if(tradedirection()==1)
  {       
    if(Close[1]>= sla1) {newsl=sl1;}
    if(Close[1]>= sla2) {newsl=sl2;}
    
    if(newsl>currentsl && newsl != 0)
    {
      for(cnt=0;cnt<OrdersTotal();cnt++)   
      {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
        {OrderModify(OrderTicket(),OrderOpenPrice(),newsl,OrderTakeProfit(),0,Blue);}   
      } 
    }
  }
  else if(tradedirection()==0)
  {    
    if(Close[1]<= sla1) {newsl=sl1;}
    if(Close[1]<= sla2) {newsl=sl2;}
    
    if(newsl<currentsl && newsl != 0)
    {
      for(cnt=0;cnt<OrdersTotal();cnt++)   
      {
        OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
        if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
        {OrderModify(OrderTicket(),OrderOpenPrice(),newsl,OrderTakeProfit(),0,Blue);}   
      } 
    }
  }
}


int opentrades()
{
  int trades=0;
  int cnt;
  
  for(cnt=0;cnt<OrdersTotal();cnt++)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);  
    if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber) {trades ++;}
  }     
  return(trades);
}


int endofday()
{
  int dayend=0; 
  if(Hour()==enday) {dayend=1;}
  if(DayOfWeek()==5 && Hour()==endayfriday) {dayend=1;}
  return(dayend);
}

void closealltrades()
{
  int cnt;
  for(cnt=0;cnt<10;cnt++)
  {
    closetrades();
    if(opentrades()==0){cnt=10;}
  }
}  
  

void closetrades()
{
  int cnt;
  for(cnt=0;cnt<OrdersTotal();cnt++)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
	 {		
	 	 if(OrderType() == 1) 	
	 	 {OrderClose(OrderTicket(),OrderLots(),Ask,slippage,Yellow);}
	 	 else {OrderClose(OrderTicket(),OrderLots(),Bid,slippage,Yellow);}
	 }
  }
}

int tradedirection()
{

  int cnt;
  int direction;
  
  for(cnt=OrdersTotal();cnt>=0;cnt--)   
  {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	 if (OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber)
	 {				
	 	 if (OrderType() == 0) {direction=1;}
	 	 if (OrderType() == 1) {direction=0;}
	 	 cnt=-1;
	 }
  }
  return (direction);
}
 
int tradingtime(int Start_time)
{

  int trading=0;
  
  if(Start_time<endtradingtime && Hour()<endtradingtime && Hour()>Start_time) {trading=1;}
  if(Start_time>endtradingtime)
  {
    if(Hour()>Start_time)    {trading=1;}
    if(Hour()<endtradingtime){trading=1;}
  }
  return(trading);
}
//+---------------------------------------------------------------------------+
//|                              THE END                                      |
//+---------------------------------------------------------------------------+